| Flutter Impeller |

Classes | Functions
std Namespace Reference

## Classes
struct | hash< impeller::UniqueID >
struct | less< impeller::UniqueID >
struct | hash< impeller::DepthAttachmentDescriptor >
struct | hash< impeller::StencilAttachmentDescriptor >
struct | hash< impeller::Font::Metrics >
struct | hash< impeller::Glyph >
struct | equal_to< impeller::Glyph >
struct | less< impeller::Glyph >

## Functions
std::ostream & | operator<< (std::ostream &out, const impeller::Arc &a)
std::ostream & | operator<< (std::ostream &out, const impeller::Color &c)
std::ostream & | operator<< (std::ostream &out, const impeller::BlendMode &mode)
std::ostream & | operator<< (std::ostream &out, const impeller::Half &p)
std::ostream & | operator<< (std::ostream &out, const impeller::HalfVector2 &p)
std::ostream & | operator<< (std::ostream &out, const impeller::HalfVector3 &p)
std::ostream & | operator<< (std::ostream &out, const impeller::HalfVector4 &p)
std::ostream & | operator<< (std::ostream &out, const impeller::Matrix &m)
template<class T >
std::ostream & | operator<< (std::ostream &out, const impeller::TPoint< T > &p)
std::ostream & | operator<< (std::ostream &out, const impeller::Quaternion &q)
template<class T >
std::ostream & | operator<< (std::ostream &out, const impeller::TRect< T > &r)
std::ostream & | operator<< (std::ostream &out, const impeller::RoundRect &rr)
std::ostream & | operator<< (std::ostream &out, const impeller::RoundSuperellipse &rr)
std::ostream & | operator<< (std::ostream &out, const impeller::RoundingRadii &rr)
std::ostream & | operator<< (std::ostream &out, const impeller::RSTransform &rst)
std::ostream & | operator<< (std::ostream &out, const impeller::Degrees &d)
std::ostream & | operator<< (std::ostream &out, const impeller::Radians &r)
template<class T >
std::ostream & | operator<< (std::ostream &out, const impeller::TSize< T > &s)
std::ostream & | operator<< (std::ostream &out, const impeller::Vector3 &p)
std::ostream & | operator<< (std::ostream &out, const impeller::Vector4 &p)
std::ostream & | operator<< (std::ostream &out, const impeller::HandleGLES &handle)

## Function Documentation

## ◆ operator<<() [1/21]

std::ostream& std::operator<< | ( | std::ostream & | out,
|  | const impeller::Arc & | a
| ) |  |
| inline

Definition at line 141 of file arc.h.

141 {
142 out << "Arc(" << a.GetOvalBounds() << ", " << a.GetStart() << " + "
143 << a.GetSweep()
144 << (a.IncludeCenter() ? ", with center)" : ", without center)");
145 return out;
146 }
impeller::Arc::IncludeCenter
constexpr bool IncludeCenter() const
Definition: arc.h:110
impeller::Arc::GetOvalBounds
const Rect & GetOvalBounds() const
Return the bounds of the oval in which this arc is inscribed.
Definition: arc.h:94
impeller::Arc::GetSweep
constexpr Degrees GetSweep() const
Definition: arc.h:108
impeller::Arc::GetStart
constexpr Degrees GetStart() const
Definition: arc.h:106

References impeller::Arc::GetOvalBounds(), impeller::Arc::GetStart(), impeller::Arc::GetSweep(), and impeller::Arc::IncludeCenter().

## ◆ operator<<() [2/21]

std::ostream& std::operator<< | ( | std::ostream & | out,
|  | const impeller::BlendMode & | mode
| ) |  |
| inline

Definition at line 933 of file color.h.

934 {
935 out << "BlendMode::k" << BlendModeToString(mode);
936 return out;
937 }
impeller::BlendModeToString
const char * BlendModeToString(BlendMode blend_mode)
Definition: color.cc:47

References impeller::BlendModeToString().

## ◆ operator<<() [3/21]

std::ostream& std::operator<< | ( | std::ostream & | out,
|  | const impeller::Color & | c
| ) |  |
| inline

Definition at line 927 of file color.h.

927 {
928 out << "(" << c.red << ", " << c.green << ", " << c.blue << ", " << c.alpha
929 << ")";
930 return out;
931 }
impeller::Color::blue
Scalar blue
Definition: color.h:138
impeller::Color::alpha
Scalar alpha
Definition: color.h:143
impeller::Color::red
Scalar red
Definition: color.h:128
impeller::Color::green
Scalar green
Definition: color.h:133

References impeller::Color::alpha, impeller::Color::blue, impeller::Color::green, and impeller::Color::red.

## ◆ operator<<() [4/21]

std::ostream& std::operator<< | ( | std::ostream & | out,
|  | const impeller::Degrees & | d
| ) |  |
| inline

Definition at line 126 of file scalar.h.

126 {
127 return out << "Degrees(" << d.degrees << ")";
128 }
impeller::Degrees::degrees
Scalar degrees
Definition: scalar.h:77

References impeller::Degrees::degrees.

## ◆ operator<<() [5/21]

std::ostream& std::operator<< | ( | std::ostream & | out,
|  | const impeller::Half & | p
| ) |  |
| inline

Definition at line 163 of file half.h.

163 {
164 out << "(" << static_cast<impeller::Scalar>(p.x) << ")";
165 return out;
166 }
impeller::Scalar
float Scalar
Definition: scalar.h:19
impeller::Half::x
InternalHalf x
Definition: half.h:42

References impeller::Half::x.

## ◆ operator<<() [6/21]

std::ostream& std::operator<< | ( | std::ostream & | out,
|  | const impeller::HalfVector2 & | p
| ) |  |
| inline

Definition at line 168 of file half.h.

169 {
170 out << "(" << static_cast<impeller::Scalar>(p.x) << ", "
171 << static_cast<impeller::Scalar>(p.y) << ")";
172 return out;
173 }
impeller::HalfVector2::x
InternalHalf x
Definition: half.h:132
impeller::HalfVector2::y
InternalHalf y
Definition: half.h:133

References impeller::HalfVector2::x, and impeller::HalfVector2::y.

## ◆ operator<<() [7/21]

std::ostream& std::operator<< | ( | std::ostream & | out,
|  | const impeller::HalfVector3 & | p
| ) |  |
| inline

Definition at line 175 of file half.h.

176 {
177 out << "(" << static_cast<impeller::Scalar>(p.x) << ", "
178 << static_cast<impeller::Scalar>(p.y) << ", "
179 << static_cast<impeller::Scalar>(p.z) << ")";
180 return out;
181 }
impeller::HalfVector3::x
InternalHalf x
Definition: half.h:104
impeller::HalfVector3::z
InternalHalf z
Definition: half.h:106
impeller::HalfVector3::y
InternalHalf y
Definition: half.h:105

References impeller::HalfVector3::x, impeller::HalfVector3::y, and impeller::HalfVector3::z.

## ◆ operator<<() [8/21]

std::ostream& std::operator<< | ( | std::ostream & | out,
|  | const impeller::HalfVector4 & | p
| ) |  |
| inline

Definition at line 183 of file half.h.

184 {
185 out << "(" << static_cast<impeller::Scalar>(p.x) << ", "
186 << static_cast<impeller::Scalar>(p.y) << ", "
187 << static_cast<impeller::Scalar>(p.z) << ", "
188 << static_cast<impeller::Scalar>(p.w) << ")";
189 return out;
190 }
impeller::HalfVector4::x
InternalHalf x
Definition: half.h:63
impeller::HalfVector4::w
InternalHalf w
Definition: half.h:66
impeller::HalfVector4::y
InternalHalf y
Definition: half.h:64
impeller::HalfVector4::z
InternalHalf z
Definition: half.h:65

References impeller::HalfVector4::w, impeller::HalfVector4::x, impeller::HalfVector4::y, and impeller::HalfVector4::z.

## ◆ operator<<() [9/21]

std::ostream& std::operator<< | ( | std::ostream & | out,
|  | const impeller::HandleGLES & | handle
| ) |  |
| inline

Definition at line 109 of file handle_gles.h.

110 {
111 out << HandleTypeToString(handle.GetType()) << "(";
112 if (handle.IsDead()) {
113 out << "DEAD";
114 } else {
115 const std::optional<impeller::UniqueID>& name = handle.GetName();
116 if (name.has_value()) {
117 out << name.value().id;
118 } else {
119 out << "UNNAMED";
120 }
121 }
122 out << ")";
123 return out;
124 }
impeller::HandleGLES::IsDead
constexpr bool IsDead() const
Determines if the handle is dead.
Definition: handle_gles.h:53
impeller::HandleGLES::GetName
const std::optional< UniqueID > & GetName() const
Definition: handle_gles.h:75
impeller::HandleGLES::GetType
HandleType GetType() const
Definition: handle_gles.h:74
impeller::HandleTypeToString
std::string HandleTypeToString(HandleType type)
Definition: handle_gles.cc:11

References impeller::HandleGLES::GetName(), impeller::HandleGLES::GetType(), impeller::HandleTypeToString(), and impeller::HandleGLES::IsDead().

## ◆ operator<<() [10/21]

std::ostream& std::operator<< | ( | std::ostream & | out,
|  | const impeller::Matrix & | m
| ) |  |
| inline

Definition at line 661 of file matrix.h.

661 {
662 out << "(" << std::endl << std::fixed;
663 for (size_t i = 0; i < 4u; i++) {
664 for (size_t j = 0; j < 4u; j++) {
665 out << std::setw(15) << m.e[j][i] << ",";
666 }
667 out << std::endl;
668 }
669 out << ")";
670 return out;
671 }
impeller::Matrix::e
Scalar e[4][4]
Definition: matrix.h:40

References impeller::Matrix::e.

## ◆ operator<<() [11/21]

std::ostream& std::operator<< | ( | std::ostream & | out,
|  | const impeller::Quaternion & | q
| ) |  |
| inline

Definition at line 94 of file quaternion.h.

95 {
96 out << "(" << q.x << ", " << q.y << ", " << q.z << ", " << q.w << ")";
97 return out;
98 }
impeller::Quaternion::y
Scalar y
Definition: quaternion.h:18
impeller::Quaternion::z
Scalar z
Definition: quaternion.h:19
impeller::Quaternion::w
Scalar w
Definition: quaternion.h:20
impeller::Quaternion::x
Scalar x
Definition: quaternion.h:17

References impeller::Quaternion::w, impeller::Quaternion::x, impeller::Quaternion::y, and impeller::Quaternion::z.

## ◆ operator<<() [12/21]

std::ostream& std::operator<< | ( | std::ostream & | out,
|  | const impeller::Radians & | r
| ) |  |
| inline

Definition at line 130 of file scalar.h.

130 {
131 return out << "Radians(" << r.radians << ")";
132 }
impeller::Radians::radians
Scalar radians
Definition: scalar.h:45

References impeller::Radians::radians.

## ◆ operator<<() [13/21]

std::ostream& std::operator<< | ( | std::ostream & | out,
|  | const impeller::RoundingRadii & | rr
| ) |  |
| inline

Definition at line 97 of file rounding_radii.h.

98 {
99 out << "(" //
100 << "ul: " << rr.top_left << ", " //
101 << "ur: " << rr.top_right << ", " //
102 << "ll: " << rr.bottom_left << ", " //
103 << "lr: " << rr.bottom_right //
104 << ")";
105 return out;
106 }
impeller::RoundingRadii::top_right
Size top_right
Definition: rounding_radii.h:16
impeller::RoundingRadii::bottom_left
Size bottom_left
Definition: rounding_radii.h:17
impeller::RoundingRadii::bottom_right
Size bottom_right
Definition: rounding_radii.h:18
impeller::RoundingRadii::top_left
Size top_left
Definition: rounding_radii.h:15

References impeller::RoundingRadii::bottom_left, impeller::RoundingRadii::bottom_right, impeller::RoundingRadii::top_left, and impeller::RoundingRadii::top_right.

## ◆ operator<<() [14/21]

std::ostream& std::operator<< | ( | std::ostream & | out,
|  | const impeller::RoundRect & | rr
| ) |  |
| inline

Definition at line 204 of file round_rect.h.

205 {
206 out << "(" //
207 << "rect: " << rr.GetBounds() << ", " //
208 << "radii: " << rr.GetRadii() //
209 << ")";
210 return out;
211 }
impeller::RoundRect::GetRadii
constexpr const RoundingRadii & GetRadii() const
Definition: round_rect.h:55
impeller::RoundRect::GetBounds
constexpr const Rect & GetBounds() const
Definition: round_rect.h:53

References impeller::RoundRect::GetBounds(), and impeller::RoundRect::GetRadii().

## ◆ operator<<() [15/21]

std::ostream& std::operator<< | ( | std::ostream & | out,
|  | const impeller::RoundSuperellipse & | rr
| ) |  |
| inline

Definition at line 177 of file round_superellipse.h.

178 {
179 out << "(" //
180 << "rect: " << rr.GetBounds() << ", " //
181 << "radii: " << rr.GetRadii();
182 out << ")";
183 return out;
184 }
impeller::RoundSuperellipse::GetRadii
constexpr const RoundingRadii & GetRadii() const
Definition: round_superellipse.h:50
impeller::RoundSuperellipse::GetBounds
constexpr const Rect & GetBounds() const
Definition: round_superellipse.h:49

References impeller::RoundSuperellipse::GetBounds(), and impeller::RoundSuperellipse::GetRadii().

## ◆ operator<<() [16/21]

std::ostream& std::operator<< | ( | std::ostream & | out,
|  | const impeller::RSTransform & | rst
| ) |  |
| inline

Definition at line 72 of file rstransform.h.

73 {
74 // clang-format off
75 out << "("
76 << "scos: " << rst.scaled_cos << ", "
77 << "ssin: " << rst.scaled_sin << ", "
78 << "origin: (" << rst.translate_x << ", "
79 << rst.translate_y << ")"
80 << ")";
81 // clang-format on
82 return out;
83 }
impeller::RSTransform::translate_y
Scalar translate_y
Definition: rstransform.h:46
impeller::RSTransform::translate_x
Scalar translate_x
Definition: rstransform.h:45
impeller::RSTransform::scaled_sin
Scalar scaled_sin
Definition: rstransform.h:44
impeller::RSTransform::scaled_cos
Scalar scaled_cos
Definition: rstransform.h:43

References impeller::RSTransform::scaled_cos, impeller::RSTransform::scaled_sin, impeller::RSTransform::translate_x, and impeller::RSTransform::translate_y.

## ◆ operator<<() [17/21]

template<class T >

std::ostream& std::operator<< | ( | std::ostream & | out,
|  | const impeller::TPoint< T > & | p
| ) |  |
| inline

Definition at line 350 of file point.h.

351 {
352 out << "(" << p.x << ", " << p.y << ")";
353 return out;
354 }
impeller::TPoint::y
Type y
Definition: point.h:31
impeller::TPoint::x
Type x
Definition: point.h:30

References impeller::TPoint< T >::x, and impeller::TPoint< T >::y.

## ◆ operator<<() [18/21]

template<class T >

std::ostream& std::operator<< | ( | std::ostream & | out,
|  | const impeller::TRect< T > & | r
| ) |  |
| inline

Definition at line 805 of file rect.h.

806 {
807 out << "(" << r.GetLeftTop() << " => " << r.GetRightBottom() << ")";
808 return out;
809 }
impeller::TRect::GetRightBottom
constexpr TPoint< T > GetRightBottom() const
Definition: rect.h:375
impeller::TRect::GetLeftTop
constexpr TPoint< T > GetLeftTop() const
Definition: rect.h:363

References impeller::TRect< T >::GetLeftTop(), and impeller::TRect< T >::GetRightBottom().

## ◆ operator<<() [19/21]

template<class T >

std::ostream& std::operator<< | ( | std::ostream & | out,
|  | const impeller::TSize< T > & | s
| ) |  |
| inline

Definition at line 171 of file size.h.

172 {
173 out << "(" << s.width << ", " << s.height << ")";
174 return out;
175 }
impeller::TSize::height
Type height
Definition: size.h:29
impeller::TSize::width
Type width
Definition: size.h:28

References impeller::TSize< T >::height, and impeller::TSize< T >::width.

## ◆ operator<<() [20/21]

std::ostream& std::operator<< | ( | std::ostream & | out,
|  | const impeller::Vector3 & | p
| ) |  |
| inline

Definition at line 330 of file vector.h.

330 {
331 out << "(" << p.x << ", " << p.y << ", " << p.z << ")";
332 return out;
333 }
impeller::Vector3::x
Scalar x
Definition: vector.h:23
impeller::Vector3::y
Scalar y
Definition: vector.h:24
impeller::Vector3::z
Scalar z
Definition: vector.h:25

References impeller::Vector3::x, impeller::Vector3::y, and impeller::Vector3::z.

## ◆ operator<<() [21/21]

std::ostream& std::operator<< | ( | std::ostream & | out,
|  | const impeller::Vector4 & | p
| ) |  |
| inline

Definition at line 335 of file vector.h.

335 {
336 out << "(" << p.x << ", " << p.y << ", " << p.z << ", " << p.w << ")";
337 return out;
338 }
impeller::Vector4::y
Scalar y
Definition: vector.h:236
impeller::Vector4::w
Scalar w
Definition: vector.h:238
impeller::Vector4::x
Scalar x
Definition: vector.h:235
impeller::Vector4::z
Scalar z
Definition: vector.h:237

References impeller::Vector4::w, impeller::Vector4::x, impeller::Vector4::y, and impeller::Vector4::z.